
#ifndef __STTRANSFORM_H__
#define __STTRANSFORM_H__


/**
* STTransform represents a transform.  At the moment this is not an arbitrary
* transform, just a composition of scales, rotates, and translates.
*/
class STTransform {

	public:

		STTransform();
		STTransform(const STTransform& xform);

		void  SetRotate(float theta, float x, float y, float z);
		void  GetRotate(float& theta, float& x, float& y, float& z);

		void  SetTranslate(float xtrans, float ytrans, float ztrans);
		void  GetTranslate(float& xtrans, float& ytrans, float& ztrans);

		void  SetScale(float scale);
		void  SetScale(float xscale, float yscale, float zscale);
		void  GetScale(float& xscale, float& yscale, float& zscale);

		static STTransform Rotate(float theta, float x, float y, float z);
		static STTransform Translate(float xtrans, float ytrans, float ztrans);

	private:

		float		  mRotTheta;
		float         mRotAxis[3];
		float		  mTranslate[3];
		float		  mScale[3];
};


#endif  // __STTRANSFORM_H__

